<?php

namespace App\Http\Controllers;

use App\Models\CredencialCliente;
use Illuminate\Http\JsonResponse;
use Illuminate\Http\Request;

class CredencialClienteController extends Controller
{
    /**
     * Display a listing of the resource.
     */
    public function index(): JsonResponse
    {
        $items = CredencialCliente::all();

        return response()->json([
            'success' => true,
            'data' => $items,
            'message' => 'Registros obtenidos correctamente',
        ], 200);
    }

    /**
     * Store a newly created resource in storage.
     */
    public function store(Request $request): JsonResponse
    {
        $payload = $request->only((new CredencialCliente())->getFillable());
        $credencialCliente = CredencialCliente::create($payload);

        return response()->json([
            'success' => true,
            'data' => $credencialCliente,
            'message' => 'Registro creado correctamente',
        ], 201);
    }

    /**
     * Display the specified resource.
     */
    public function show(CredencialCliente $credencialCliente): JsonResponse
    {
        return response()->json([
            'success' => true,
            'data' => $credencialCliente,
            'message' => 'Registro obtenido correctamente',
        ], 200);
    }

    /**
     * Update the specified resource in storage.
     */
    public function update(Request $request, CredencialCliente $credencialCliente): JsonResponse
    {
        $payload = $request->only((new CredencialCliente())->getFillable());
        $credencialCliente->update($payload);

        return response()->json([
            'success' => true,
            'data' => $credencialCliente,
            'message' => 'Registro actualizado correctamente',
        ], 200);
    }

    /**
     * Remove the specified resource from storage.
     */
    public function destroy(CredencialCliente $credencialCliente): JsonResponse
    {
        $credencialCliente->delete();

        return response()->json([
            'success' => true,
            'message' => 'Registro eliminado correctamente',
        ], 200);
    }
}